

from util_functions.melodic_components import chord_data


def new_arrangement(previous_arrangement, 
                    reference_key, 
                    previous_chord, 
                    next_chord, 
                    increasing):
    
    (current_chordal_notes, 
     current_scale, 
     current_melodic_range) = chord_data(key=reference_key, 
                                         current_chord=next_chord, 
                                         possible_octaves=(2,3,4,5,6))    
    (previous_chordal_notes, 
     previous_scale, 
     previous_melodic_range) = chord_data(key=reference_key, 
                                         current_chord=previous_chord, 
                                         possible_octaves=(2,3,4,5,6))  
    (previous_bass,
     previous_tenor,
     previous_alto, 
     previous_soprano) = previous_arrangement
    
    if previous_bass not in previous_melodic_range:
        previous_bass = [x for x in previous_melodic_range
                        if x[0] == previous_bass[0]][0][:-1]+previous_bass[-1]
    previous_bass_idx = previous_melodic_range.index(previous_bass)
    if previous_tenor not in previous_melodic_range:
        previous_tenor = [x for x in previous_melodic_range
                        if x[0] == previous_tenor[0]][0][:-1]+previous_tenor[-1]    
    previous_tenor_idx = previous_melodic_range.index(previous_tenor)
    if previous_alto not in previous_melodic_range:
        previous_alto = [x for x in previous_melodic_range
                        if x[0] == previous_alto[0]][0][:-1]+previous_alto[-1]    
    previous_alto_idx = previous_melodic_range.index(previous_alto)
    if previous_soprano not in previous_melodic_range:
        previous_soprano = [x for x in previous_melodic_range
                        if x[0] == previous_soprano[0]][0][:-1]+previous_soprano[-1]    
    previous_soprano_idx = previous_melodic_range.index(previous_soprano)
    
    if increasing:       
        possible_bass_idxs =  [idx 
                               for idx in range(len(current_melodic_range))
                               if idx > previous_bass_idx
                               and current_melodic_range[idx][:-1] 
                               in current_chordal_notes]
        current_bass_idx = min(possible_bass_idxs)
        current_bass = current_melodic_range[current_bass_idx]
        
        if len(current_chordal_notes) == 3:
            possible_soprano_idxs =  [idx 
                                      for idx in range(len(current_melodic_range))
                                      if idx > previous_soprano_idx
                                      and current_melodic_range[idx][:-1] 
                                      in current_chordal_notes]
        else:
            possible_soprano_idxs =  [idx 
                                      for idx in range(len(current_melodic_range))
                                      if idx > previous_soprano_idx
                                      and current_melodic_range[idx][:-1] 
                                      in current_chordal_notes 
                                      and current_melodic_range[idx][:-1] 
                                      != current_bass[:-1]]    
        current_soprano_idx = min(possible_soprano_idxs) 
        current_soprano = current_melodic_range[current_soprano_idx]  

    else:
        possible_bass_idxs =  [idx 
                               for idx in range(len(current_melodic_range))
                               if idx < previous_bass_idx
                               and current_melodic_range[idx][:-1] 
                               in current_chordal_notes]

        if len(possible_bass_idxs) == 0:
            possible_bass_idxs =  [idx 
                                   for idx in range(len(current_melodic_range))
                                   if current_melodic_range[idx][:-1] 
                                   in current_chordal_notes]            
            current_bass_idx = min(possible_bass_idxs)
        else:
            current_bass_idx = max(possible_bass_idxs)
        current_bass = current_melodic_range[current_bass_idx]
        
        if len(current_chordal_notes) == 3:
            possible_soprano_idxs =  [idx 
                                      for idx in range(len(current_melodic_range))
                                      if idx < previous_soprano_idx
                                      and current_melodic_range[idx][:-1] 
                                      in current_chordal_notes]
        else:
            possible_soprano_idxs =  [idx 
                                      for idx in range(len(current_melodic_range))
                                      if idx < previous_soprano_idx
                                      and current_melodic_range[idx][:-1] 
                                      in current_chordal_notes 
                                      and current_melodic_range[idx][:-1] 
                                      != current_bass[:-1]]    
        current_soprano_idx = max(possible_soprano_idxs) 
        current_soprano = current_melodic_range[current_soprano_idx]          
    
    possible_middle_notes = [n for n in current_chordal_notes
                             if n not in (current_bass[:-1], current_soprano[:-1])]
    if len(possible_middle_notes) == 1:
        possible_middle_notes.append(current_chordal_notes[0])
        
    possible_middle_idxs = [n
                            for n in range(len(current_melodic_range))
                            if n >= current_bass_idx
                            and n <= current_soprano_idx
                            and current_melodic_range[n][:-1]
                            in possible_middle_notes]
    if len(possible_middle_idxs) == 0:
        possible_middle_idxs = [n
                                for n in range(len(current_melodic_range))
                                if current_melodic_range[n][:-1]
                                in possible_middle_notes]        
    previous_alto_dist = [abs(previous_alto_idx-idx)
                          for idx in possible_middle_idxs]
    previous_tenor_dist = [abs(previous_tenor_idx-idx)
                          for idx in possible_middle_idxs]       
    alto_tenor_combination = []
    combination_idxs = []
    for idx1 in range(len(possible_middle_idxs)):
        for idx2 in range(len(possible_middle_idxs)):
            if idx1 != idx2:
                alto_tenor_combination.append(previous_alto_dist[idx1]
                                              +previous_tenor_dist[idx2])
                combination_idxs.append((idx1, idx2))
    if len(alto_tenor_combination) == 0:
        current_tenor_idx = possible_middle_idxs[previous_tenor_dist.index(min(previous_tenor_dist))]
        current_alto_idx = possible_middle_idxs[previous_alto_dist.index(min(previous_alto_dist))]
    else:
        current_combination_idxs = combination_idxs[alto_tenor_combination.index(min(alto_tenor_combination))]
        current_tenor_idx = possible_middle_idxs[current_combination_idxs[1]]
        current_alto_idx = possible_middle_idxs[current_combination_idxs[0]]    
    current_tenor = current_melodic_range[current_tenor_idx]
    current_alto = current_melodic_range[current_alto_idx]
    
    return [current_bass, current_tenor, current_alto, current_soprano]