

from util_functions.harmonic_components import subord_chord

def left_development(chord_labels, 
                     key_roman, 
                     first, 
                     key, 
                     rep, 
                     norm):

    left_subordinates = []
    for idx in range(len(chord_labels)):

        if idx == 0:    # i.e. First Chord
            right_branched = True
        elif idx == -1:    # i.e. Last Chord
            right_branched = False
        else:
            right_branched = False

        dominating_chord = chord_labels[idx].replace('7', '').replace('+', '').replace('-', '')
        left_subordinates.append(subord_chord(right_branched, 
                                              key_roman, 
                                              dominating_chord, 
                                              first, 
                                              key, 
                                              rep, 
                                              norm))
    return left_subordinates

def right_development(chord_labels, 
                     key_roman, 
                     first, 
                     key, 
                     rep, 
                     norm):

    right_subordinates = []
    for idx in range(len(chord_labels)):

        if idx == 0:    # i.e. First Chord
            right_branched = True
        elif idx == -1:    # i.e. Last Chord
            right_branched = False
        else:
            right_branched = True

        dominating_chord = chord_labels[idx].replace('7', '').replace('+', '').replace('-', '')
        right_subordinates.append(subord_chord(right_branched, 
                                               key_roman, 
                                               dominating_chord, 
                                               first, 
                                               key, 
                                               rep, 
                                               norm))
    return right_subordinates