

from util_functions.harmonic_morphing import roman_to_key, key_to_roman, new_subordinate

def data_initialisation(themes_data,
                        chord_idx,
                        current_key):
    
    dominating_label = themes_data['chord_labels'][chord_idx-1]           
    dominating_alphabet = roman_to_key(current_key, dominating_label.split('/')[-1])
    dominating_key = key_to_roman('C', dominating_alphabet)
    dominating_chord = dominating_label.split('/')[0]+'/'+dominating_key                
    reference_melody = themes_data['melody_by_bars'][chord_idx-1]
    reference_rhythm = themes_data['rhythm_by_bars'][chord_idx-1]    
    previous_label = themes_data['chord_labels'][chord_idx-1]
    previous_alphabet = roman_to_key(current_key, previous_label.split('/')[-1])
    previous_key = key_to_roman('C', previous_alphabet)
    previous_chord = previous_label.split('/')[0]+'/'+previous_key        
    chord_sequence = themes_data['chord_labels'][:chord_idx]
        
    return (dominating_label,
            dominating_alphabet,
            dominating_key,
            dominating_chord,
            reference_melody,
            reference_rhythm,
            previous_chord,
            chord_sequence)    