

import os
import pygame
import music21

def play(midi_stream, file_name):

    mf = music21.midi.translate.streamToMidiFile(midi_stream)
    
    path = os.getcwd()
    file = path + '/' + file_name
    mf.open(file, 'wb')
    mf.write()
    mf.close()

    pygame.init()

    pygame.mixer.music.load(file)
    pygame.mixer.music.play()
    
    
    
from midiutil.MidiFile import MIDIFile
from io import BytesIO

def player(melody_bars,
           midi_numbers,
           enh,
           durations_bars,
           satb_bars,
           current_bpm,
           current_loudness,
           chord_dur_bars):
    
    memFile = BytesIO()
    MyMIDI = MIDIFile(1)
    
    MyMIDI.addTrackName(track = 0,
                        time = 0,
                        trackName = "Sample Track")
    MyMIDI.addTempo(track = 0,
                    time = 0,
                    tempo = current_bpm)
        
    # Melody
    onset = 0
    for note_idx in range(len(melody_bars)):
        if melody_bars[note_idx] != 'rest':
            note = melody_bars[note_idx]
            if note not in list(midi_numbers):
                if note[:-1] == 'b#':
                    note = enh[note[:-1]]+str(int(note[-1])+1)                   
                elif note[:-1] == 'cb':
                    note = enh[note[:-1]]+str(int(note[-1])-1)                    
                else:     
                    note = enh[note[:-1]]+note[-1]
            note = midi_numbers[note][0]
            MyMIDI.addNote(track = 0,
                           channel = 0,
                           pitch = note,
                           time = onset,
                           duration = durations_bars[note_idx],
                           volume = current_loudness+7)
        onset += durations_bars[note_idx]
        
    # Chord notes
    bass = satb_bars[0]
    if bass not in list(midi_numbers):
        if bass[:-1] == 'b#':
            bass = enh[bass[:-1]]+str(int(bass[-1])+1)                   
        elif bass[:-1] == 'cb':
            bass = enh[bass[:-1]]+str(int(bass[-1])-1)                    
        else:     
            bass = enh[bass[:-1]]+bass[-1]    
    tenor = satb_bars[1]
    if tenor not in list(midi_numbers):
        if tenor[:-1] == 'b#':
            tenor = enh[tenor[:-1]]+str(int(tenor[-1])+1)                   
        elif tenor[:-1] == 'cb':
            tenor = enh[tenor[:-1]]+str(int(tenor[-1])-1)                    
        else:     
            tenor = enh[tenor[:-1]]+tenor[-1]    
    alto = satb_bars[2]
    if alto not in list(midi_numbers):
        if alto[:-1] == 'b#':
            alto = enh[alto[:-1]]+str(int(alto[-1])+1)                   
        elif alto[:-1] == 'cb':
            alto = enh[alto[:-1]]+str(int(alto[-1])-1)                    
        else:     
            alto = enh[alto[:-1]]+alto[-1]   
    soprano = satb_bars[3]
    if soprano not in list(midi_numbers):
        if soprano[:-1] == 'b#':
            soprano = enh[soprano[:-1]]+str(int(soprano[-1])+1)                   
        elif soprano[:-1] == 'cb':
            soprano = enh[soprano[:-1]]+str(int(soprano[-1])-1)                    
        else:     
            soprano = enh[soprano[:-1]]+soprano[-1]    
        
    # Bass
    MyMIDI.addNote(track = 0,
                   channel = 1,
                   pitch = midi_numbers[bass][0],
                   time = 0,
                   duration = chord_dur_bars+.5,
                   volume = current_loudness)    
    # Tenor
    MyMIDI.addNote(track = 0,
                   channel = 2,
                   pitch = midi_numbers[tenor][0],
                   time = 0,
                   duration = chord_dur_bars+.5,
                   volume = current_loudness)      
    # Alto
    MyMIDI.addNote(track = 0,
                   channel = 3,
                   pitch = midi_numbers[alto][0],
                   time = 0,
                   duration = chord_dur_bars+.5,
                   volume = current_loudness)      
    # Soprano
    MyMIDI.addNote(track = 0,
                   channel = 4,
                   pitch = midi_numbers[soprano][0],
                   time = 0,
                   duration = chord_dur_bars+.5,
                   volume = current_loudness)  
    MyMIDI.writeFile(memFile)

    # Playback
    
    memFile.seek(0) 
    pygame.mixer.music.load(memFile)
    pygame.mixer.music.play()
    