

import os
import pandas
import numpy as np

def pb_generation(num_bars):
    
    pb_path = os.getcwd()+'/util_files/possible_pb.csv'
    df_pb = pandas.read_csv(pb_path)
    len_pb = int(num_bars/2)
    possible_pb = []

    # Reading possible pb
    for row_idx in range(len(list(df_pb['num bars']))):
        current_num_bars = list(df_pb['num bars'])[row_idx]
        if current_num_bars == len_pb:
            current_pb = []
            for bar in range(current_num_bars):
                current_pb.append(list(
                    df_pb.iloc[row_idx:row_idx+1]
                    [str(bar+1)])[0])
            possible_pb.append(current_pb)

    # Stochastic selection
    random_idx = np.random.choice([x for x in range(len(possible_pb))])
    final_pb = possible_pb[random_idx]
    
    return final_pb

def cs_generation(num_bars, len_pb, final_pb):
    
    
    cs_path = os.getcwd()+'/util_files/possible_cs.csv'
    df_cs = pandas.read_csv(cs_path)
    len_cs = num_bars - len_pb
    possible_cs = []

    # Reading possible cs
    for row_idx in range(len(list(df_cs['num bars']))):
        current_num_bars = list(df_cs['num bars'])[row_idx]
        if current_num_bars == len_cs:
            current_cs = []
            for bar in range(current_num_bars):
                current_cs.append(list(
                    df_cs.iloc[row_idx:row_idx+1]
                    [str(bar+1)])[0])
            possible_cs.append(current_cs)
            
    # Pb's harmonic rhythm
    pb_hr = [chord 
             for chord in final_pb 
             if type(chord) != float]
    
    valid_cs = []
    cs_hr = []
    for cs in possible_cs:
        cs_hr = [chord for chord in cs if type(chord) != float]
        if len(cs_hr) == len(pb_hr):
            valid_cs.append(cs)

    # Stochastic selection
    random_idx = np.random.choice([x 
                                   for x in range(
                                       len(valid_cs))])
    final_cs = valid_cs[random_idx]
    
    return final_cs
